package org.processmining.activityclusterarraycreator.connections;

import org.processmining.activityclusterarray.models.ActivityClusterArray;
import org.processmining.activityclusterarraycreator.parameters.ModifyActivityClusterArrayParameters;
import org.processmining.causalactivitygraph.models.CausalActivityGraph;
import org.processmining.framework.connections.impl.AbstractConnection;

public class ModifyActivityClusterArrayConnection extends AbstractConnection {

	public final static String GRAPH = "Graph";
	public final static String CLUSTERS = "Clusters";
	public final static String MODIFIEDCLUSTERS = "Modified Clusters";

	private ModifyActivityClusterArrayParameters parameters;

	public ModifyActivityClusterArrayConnection(ActivityClusterArray clusters, CausalActivityGraph graph,
			ActivityClusterArray modifiedClusters, ModifyActivityClusterArrayParameters parameters) {
		super("Modify Activity Cluster Array Connection");
		put(GRAPH, graph);
		put(CLUSTERS, clusters);
		put(MODIFIEDCLUSTERS, modifiedClusters);
		this.parameters = new ModifyActivityClusterArrayParameters(parameters);
	}

	public ModifyActivityClusterArrayParameters getParameters() {
		return parameters;
	}
}
