package org.processmining.activityclusterarraycreator.metrics.impl;

import java.util.ArrayList;
import java.util.List;

import org.processmining.activityclusterarray.models.ActivityClusterArray;
import org.processmining.activityclusterarraycreator.metrics.ActivityClusterArrayMetric;
import org.processmining.causalactivitygraph.models.CausalActivityGraph;
import org.processmining.framework.plugin.PluginContext;

public class ActivityClusterArrayWeightedMetric implements ActivityClusterArrayMetric {

	private List<ActivityClusterArrayMetric> metrics;
	
	public ActivityClusterArrayWeightedMetric(ActivityClusterArrayMetric... metrics) {
		this.metrics = new ArrayList<ActivityClusterArrayMetric>();
		for (ActivityClusterArrayMetric metric : metrics) {
			this.metrics.add(metric);
		}
	}
	
	public double compute(PluginContext context, ActivityClusterArray clusters, CausalActivityGraph graph) {
		double value = 0.0;
		double weight = getWeight();
		for (ActivityClusterArrayMetric metric : metrics) {
			value += (metric.compute(context, clusters, graph) * metric.getWeight() / weight);
		}
		return value;
	}

	public double getWeight() {
		double weight = 0.0;
		for (ActivityClusterArrayMetric metric : metrics) {
			weight += metric.getWeight();
		}
		return weight;
	}

}
