package org.processmining.activityclusterarraycreator.parameters;

import org.processmining.basicutils.parameters.impl.PluginParametersImpl;
import org.processmining.causalactivitygraph.models.CausalActivityGraph;

public class ConvertCausalActivityGraphToActivityClusterArrayParameters extends PluginParametersImpl {

	private boolean checkBackwardArc;
	private boolean includeAll;
	private int clusterThreshold;
	private int maxThreshold;
	private double clusterFactor;
	
	public ConvertCausalActivityGraphToActivityClusterArrayParameters(CausalActivityGraph graph) {
		super();
		setCheckBackwardArc(false);
		setIncludeAll(false);
		setClusterThreshold(graph.getActivities().size());
		setMaxThreshold(getClusterThreshold());
		setClusterFactor(0.0);
	}
	
	public ConvertCausalActivityGraphToActivityClusterArrayParameters(ConvertCausalActivityGraphToActivityClusterArrayParameters parameters) {
		super(parameters);
		setCheckBackwardArc(parameters.isCheckBackwardArc());
		setIncludeAll(parameters.isIncludeAll());
		setClusterThreshold(parameters.getClusterThreshold());
		setMaxThreshold(parameters.getMaxThreshold());
		setClusterFactor(parameters.getClusterFactor());
	}
	
	public boolean equals(Object object) {
		if (object instanceof ConvertCausalActivityGraphToActivityClusterArrayParameters) {
			ConvertCausalActivityGraphToActivityClusterArrayParameters parameters = (ConvertCausalActivityGraphToActivityClusterArrayParameters) object;
			return super.equals(parameters) && isCheckBackwardArc() == parameters.isCheckBackwardArc() &&
					isIncludeAll() == parameters.isIncludeAll() &&
					getClusterThreshold() == parameters.getClusterThreshold() &&
					getMaxThreshold() == parameters.getMaxThreshold() &&
					getClusterFactor() == parameters.getClusterFactor();
		}
		return false;
	}
	
	public void setCheckBackwardArc(boolean checkBackwardArc) {
		this.checkBackwardArc = checkBackwardArc;
	}
	
	public boolean isCheckBackwardArc() {
		return checkBackwardArc;
	}

	public void setIncludeAll(boolean includeAll) {
		this.includeAll = includeAll;
	}

	public boolean isIncludeAll() {
		return includeAll;
	}

	public int getClusterThreshold() {
		return clusterThreshold;
	}

	public void setClusterThreshold(int clusterThreshold) {
		this.clusterThreshold = clusterThreshold;
	}

	public int getMaxThreshold() {
		return maxThreshold;
	}

	public void setMaxThreshold(int maxTreshold) {
		this.maxThreshold = maxTreshold;
	}

	public double getClusterFactor() {
		return clusterFactor;
	}

	public void setClusterFactor(double clusterFactor) {
		this.clusterFactor = clusterFactor;
	}
}
