package org.processmining.activityclusterarraycreator.parameters;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.basicutils.parameters.impl.PluginParametersImpl;
import org.processmining.log.parameters.ClassifierParameter;
import org.processmining.log.utils.XUtils;

public class DiscoverClustersFromEventLogParameters extends PluginParametersImpl implements ClassifierParameter {

	private XEventClassifier classifier;
	private int clusterSize;
	private int stepSize;

	public DiscoverClustersFromEventLogParameters(XLog eventLog) {
		super();
		setClassifier(XUtils.getDefaultClassifier(eventLog));
		setClusterSize(8);
		setStepSize(1);
		setTryConnections(true);
	}

	public DiscoverClustersFromEventLogParameters(DiscoverClustersFromEventLogParameters parameters) {
		super(parameters);
		setClassifier(parameters.getClassifier());
		setClusterSize(parameters.getClusterSize());
		setStepSize(parameters.getStepSize());
	}

	public void setClassifier(XEventClassifier classifier) {
		this.classifier = classifier;
	}

	public XEventClassifier getClassifier() {
		return classifier;
	}

	public boolean equals(Object object) {
		if (object instanceof DiscoverClustersFromEventLogParameters) {
			DiscoverClustersFromEventLogParameters parameters = (DiscoverClustersFromEventLogParameters) object;
			return super.equals(parameters) && getClassifier().equals(parameters.getClassifier()) && 
					getClusterSize() == parameters.getClusterSize() && 
					getStepSize() == parameters.getStepSize();
		}
		return false;
	}

	public void setClusterSize(int clusterSize) {
		this.clusterSize = clusterSize;
	}

	public int getClusterSize() {
		return clusterSize;
	}

	public void setStepSize(int stepSize) {
		this.stepSize = stepSize;
	}

	public int getStepSize() {
		return stepSize;
	}
}
