package org.processmining.activityclusterarraycreator.parameters;

import org.processmining.activityclusterarray.models.ActivityClusterArray;
import org.processmining.activityclusterarraycreator.modifiers.ActivityClusterArrayModifierManager;
import org.processmining.activityclusterarraycreator.modifiers.ActivityClusterArrayModifierParameters;

public class ModifyActivityClusterArrayParameters extends ActivityClusterArrayModifierParameters {

	private String modifier;
	private boolean tryConnections;

	public ModifyActivityClusterArrayParameters(ActivityClusterArray clusters) {
		super(clusters);
		setModifier(ActivityClusterArrayModifierManager.getInstance().getModifier(null).getName());
		setTryConnections(true);
	}
	
	public ModifyActivityClusterArrayParameters(ModifyActivityClusterArrayParameters parameters) {
		super(parameters);
		setModifier(parameters.getModifier());
		setTryConnections(parameters.isTryConnections());
	}
	
	public boolean equals(Object object) {
		if (object instanceof ModifyActivityClusterArrayParameters) {
			ModifyActivityClusterArrayParameters parameters = (ModifyActivityClusterArrayParameters) object;
			return super.equals(parameters) &&
					getModifier().equals(parameters.getModifier()) &&
					isTryConnections() == parameters.isTryConnections();
		}
		return false;
	}
	
	public String getModifier() {
		return modifier;
	}

	public void setModifier(String modifier) {
		this.modifier = modifier;
	}

	public boolean isTryConnections() {
		return tryConnections;
	}

	public void setTryConnections(boolean tryConnections) {
		this.tryConnections = tryConnections;
	}
	
}
